#set -x
# developed by vnish team
if [ ! -f cert.pem ]; then
  echo "RUNME: CANNOT FIND CERT!" >> /tmp/upgrade_result
  rm * -rf > /dev/null 2>&1
  exit 1
fi
if [ ! -f cert.pem.sig ]; then
  echo "RUNME: CANNOT FIND CERT SIG!" >> /tmp/upgrade_result
  rm * -rf > /dev/null 2>&1
  exit 2
fi
if [ -e /etc/vnish.pem ]; then
  openssl dgst -sha256 -verify /etc/vnish.pem -signature  cert.pem.sig  cert.pem >/dev/null  2>&1 
  res=$?
  if [ $res -ne 0 ]; then
    echo "RUNME: CANNOT VERIFY CERT !" >> /tmp/upgrade_result
    rm * -rf > /dev/null 2>&1
    exit 3
  fi
fi
if [ ! -f fw.tar.gz.sig ]; then
  echo "RUNME: CANNOT FIND FW SIGNATURE!" >> /tmp/upgrade_result
  rm * -rf > /dev/null 2>&1
  exit 4
fi
openssl dgst -sha256 -verify cert.pem -signature  fw.tar.gz.sig  fw.tar.gz >/dev/null  2>&1 
res=$?
if [ $res -ne 0 ]; then
  echo "RUNME: CANNOT VERIFY FW !" >> /tmp/upgrade_result
  rm * -rf > /dev/null 2>&1
  exit 5
fi

th=$(pwd)

fileconf="/config/bmminer.conf"

grep -r "bitmain-freq" $fileconf | cut -d "\"" -f 4 > /tmp/freqtemp
grep -r "bitmain-voltage" $fileconf | cut -d "\"" -f 4 > /tmp/voltagetemp

freq=`sed -n "1p" /tmp/freqtemp`
freq1=`sed -n "2p" /tmp/freqtemp`
freq2=`sed -n "3p" /tmp/freqtemp`
freq3=`sed -n "4p" /tmp/freqtemp`
freq4=`sed -n "5p" /tmp/freqtemp`
freq5=`sed -n "6p" /tmp/freqtemp`
freq6=`sed -n "7p" /tmp/freqtemp`

voltage=`sed -n "1p" /tmp/voltagetemp`
voltage1=`sed -n "2p" /tmp/voltagetemp`
voltage2=`sed -n "3p" /tmp/voltagetemp`
voltage3=`sed -n "4p" /tmp/voltagetemp`
voltage4=`sed -n "5p" /tmp/voltagetemp`
voltage5=`sed -n "6p" /tmp/voltagetemp`
voltage6=`sed -n "7p" /tmp/voltagetemp`

if [ ${freq} ] && [ ${freq} -ne 475 ]; then
	sed -i 's,^\(\"bitmain-freq\" : \).*,\1'\"475\"\\,',' $fileconf
fi 

if [ ${freq1} ] && [ ${freq1} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq1\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq2} ] && [ ${freq2} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq2\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq3} ] && [ ${freq3} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq3\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq4} ] && [ ${freq4} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq4\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq5} ] && [ ${freq5} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq5\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${freq6} ] && [ ${freq6} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-freq6\" : \).*,\1'\"0\"\\,',' $fileconf
fi 


if [ ${voltage} ] && [ ${voltage} -ne 820 ]; then
	sed -i 's,^\(\"bitmain-voltage\" : \).*,\1'\"820\"\\,',' $fileconf
fi 

if [ ${voltage1} ] && [ ${voltage1} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage1\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage2} ] && [ ${voltage2} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage2\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage3} ] && [ ${voltage3} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage3\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage4} ] && [ ${voltage4} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage4\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage5} ] && [ ${voltage5} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage5\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

if [ ${voltage6} ] && [ ${voltage6} -ne 0 ]; then
	sed -i 's,^\(\"bitmain-voltage6\" : \).*,\1'\"0\"\\,',' $fileconf
fi 

echo NO_START=1 > /config/dropbear
mkdir /tmp/mem
mount -t tmpfs tmpfs /tmp/mem
mkdir /tmp/mem/fw 
tar zxvf fw.tar.gz -C /tmp/mem/fw > /dev/null 2>&1
rm fw.tar.gz
cd /tmp/mem/fw
sh runme.sh
sync >/dev/null 2>&1
